Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT5.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT5.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT5.m	(revision 623)
@@ -1,103 +1,103 @@
-VADPT5	;ALB/MRL/MJK - PATIENT VARIABLES [REG]; 14 DEC 1988 ; 8/6/04 7:42am
-	;;5.3;Registration;**54,63,242,584,749**;Aug 13, 1993;Build 10
-10	;Registration/Disposition [REG]
-	N VARPSV
-	S VARPSV("C")=$S('$G(VARP("C")):999999999,1:+VARP("C"))
-	S VARPSV("F")=9999999-$S($G(VARP("F"))?7N.E:VARP("F"),1:0)
-	S VARPSV("T")=$S($G(VARP("T"))?7N.E:VARP("T"),1:7777777) I '$P(VARPSV("T"),".",2) S $P(VARPSV("T"),".",2)=999999
-	S VARPSV("T")=9999999-VARPSV("T")
-	S VAX=VARPSV("T"),VAX(1)=0
-	I '$D(^DPT(DFN,"DIS")) Q
-	F I=0:0 S VAX=$O(^DPT(DFN,"DIS",VAX)) Q:VAX=""!(VAX>VARPSV("F"))!(VAX(1)+1>VARPSV("C"))  S VAX(2)=$G(^DPT(DFN,"DIS",VAX,0)),VAX(1)=VAX(1)+1 D 101:+VAX(2)>0
-	Q
-101	S (VAX("I"),VAX("E"))="",VAX(3)=0 F I=1,2,3,4,5,6,7,9 S VAX(3)=VAX(3)+1,$P(VAX("I"),"^",VAX(3))=$P(VAX(2),"^",I) D 102
-	S @VAV@(VAX(1),"I")=VAX("I"),@VAV@(VAX(1),"E")=VAX("E") Q
-102	I "^1^6^"[("^"_VAX(3)_"^") S Y=$P(VAX("I"),"^",VAX(3)) I Y]"" X ^DD("DD") S $P(VAX("E"),"^",VAX(3))=Y Q
-	S X(1)=$S($D(^DD(2.101,$S(I<9:(I-1),1:I),0)):$P(^(0),"^",3),1:"") I "^2^3^"[("^"_VAX(3)_"^"),$P(VAX("I"),"^",VAX(3))]"",X(1)]"" S $P(VAX("E"),"^",VAX(3))=$P($P(X(1),$P(VAX("I"),"^",VAX(3))_":",2),";",1) Q
-	I "^4^5^7^8^"[("^"_VAX(3)_"^"),$P(VAX("I"),"^",VAX(3))]"",X(1)]"" S X(1)="^"_X(1)_$P(VAX("I"),"^",VAX(3))_",0)" I $D(@(X(1))) S $P(VAX("E"),"^",VAX(3))=$P(^(0),"^",1)
-	Q
-	;
-11	;Clinic Enrollments [SDE]
-	S (VAX,VAX(1))=0 F I=0:0 S VAX=$O(^DPT(DFN,"DE",VAX)) Q:VAX'>0  S VAZ=$S($D(^DPT(DFN,"DE",VAX,0)):^(0),1:"") I +VAZ,$P(VAZ,"^",2)'="I" S VAX(3)=0 D 111
-	Q
-111	S VAX(4)=0 F I1=0:0 S VAX(4)=$O(^DPT(DFN,"DE",VAX,1,VAX(4))) Q:VAX(4)'>0!(VAX(3))  S VAZ(1)=$S($D(^DPT(DFN,"DE",VAX,1,VAX(4),0)):^(0),1:"") I +VAZ(1),$P(VAZ(1),"^",3)']"" S VAX(3)=VAZ(1)
-	Q:'VAX(3)  S (VAX("I"),VAX("E"))="",Y=+VAX(3),$P(VAX("I"),"^",2)=Y X ^DD("DD") S $P(VAX("E"),"^",2)=Y
-	S $P(VAX("I"),"^",3)=$P(VAX(3),"^",2) I $P(VAX("I"),"^",3)]"" S $P(VAX("E"),"^",3)=$S($P(VAX("I"),"^",3)="O":"OPT",$P(VAX("I"),"^",3)="A":"AC",1:"")
-	S $P(VAX("I"),"^",1)=+VAZ,$P(VAX("E"),"^",1)=$S($D(^SC(+VAZ,0)):$P(^(0),"^",1),1:""),VAX(1)=VAX(1)+1,@VAV@(VAX(1),"I")=VAX("I"),@VAV@(VAX(1),"E")=VAX("E") Q
-	;
-12	;Appointments [SDA]
-	N VASDSV,SDCNT,SDARRAY,VANOW
-	S VANOW=$$NOW^XLFDT
-	S VASDSV("F")=$S($G(VASD("F"))?7N.E:VASD("F"),1:VANOW)
-	S VASDSV("T")=$S(+$G(VASD("T")):+VASD("T"),1:9999999) I '$P(VASDSV("T"),".",2) S $P(VASDSV("T"),".",2)=999999
-	S VASDSV("W")=$S('$G(VASD("W")):12,1:VASD("W"))
-	S VAZ(2)=$S($D(VASD("N")):VASD("N"),1:9999)
-	;Set STATUS Codes (VistA;RSA)
-	S VAZ=";R^I;I^N;NS^NA;NSR^C;CC^CA;CCR^PC;CP^PCA;CPR^NT;NT^",VAZ(1)=""
-	;Extract User Required STATUS Codes in RSA format
-	F I=1:1 S I1=+$E(VASDSV("W"),I) Q:'I1  D
-	.S VAZ(1)=VAZ(1)_$P($P(VAZ,"^",I1),";",2)_";"
-	;Create parameter list for the extrinsic call to the Appointment API
-	;Note: Appointment API can only accept a maximum of 3 fields 
-	;               to filter on.
-	; 1 : "FROM;TO" Appointment Date Range to Search
-	; 2 : Clinic IEN or Array of Clinic IENs if defined (Pass the Root)
-	; 3 : Requested STATUS Codes (Passed if VASD("C") is not defined.)
-	; 4 : Patient IEN
-	S SDARRAY="",SDARRAY(1)=VASDSV("F")_";"_VASDSV("T")
-	I $O(VASD("C",0))>0 S SDARRAY(2)="VASD(""C"","
-	E  S SDARRAY(3)=VAZ(1)
-	S SDARRAY(4)=DFN
-	;Set Fields for API to Return
-	;  1 : Appointment Date/Time
-	;  2 : Clinic
-	;  3 : Appointment Status
-	; 10 : Appointment Type
-	S SDARRAY("FLDS")="1;2;3;10"
-	;Remove Clinic IEN from Global Reference
-	S SDARRAY("SORT")="P"
-	;Call Appointment API (Pass Array by reference)
-	S SDCNT=$$SDAPI^SDAMA301(.SDARRAY)
-	S VAX="",VAX(1)=0
-	;If error returned, determine error and set VAERR appropriately
-	; 1 : For any error other than 101
-	; 2 : If error is 101 : Database is unavailable  
-	I SDCNT<0 S VAX=$O(^TMP($J,"SDAMA301",VAX)) S VAERR=$S(VAX=101:2,1:1) K ^TMP($J,"SDAMA301") Q
-	D 122:SDCNT>0
-	Q
-121	S VAX(5)=1 I VASDSV("W")'[1,$P(VAZ,"^",2)']"" S VAX(5)=0 Q
-	I VASDSV("C"),'$D(VASD("C",+VAZ)) S VAX(5)=0 Q
-	S (VAX("I"),VAX("E"))="",VAX(2)=1,$P(VAX("I"),"^",1)=+VAX F I1=1,2,16 S VAX(2)=VAX(2)+1,$P(VAX("I"),"^",VAX(2))=$P(VAZ,"^",I1)
-	Q
-122	;Build Internal/External Output Globals
-	;
-	N SDCIEN,SDDTM,SDNODE
-	S (SDCIEN,SDDTM)=""
-	;Redefine VAZ (STATUS Codes(RSA;VistA))
-	S VAZ="R;^I;I^NS;N^NSR;NA^CC;C^CCR;CA^CP;PC^CPR;PCA^NT;NT^"
-	S SDDTM=""
-	;Loop through appointments and convert for output
-	F  S SDDTM=$O(^TMP($J,"SDAMA301",DFN,SDDTM)) Q:'SDDTM  D 
-	.;Get Appointment Information and clear VAX("I") & VAX("E")
-	.S SDNODE=^(SDDTM),(VAX("I"),VAX("E"))=""
-	.;If Clinics were passed to appointment API,
-	.;     Filter on Appointment Status Codes
-	.I $O(VASD("C",0))>0,(VAZ(1)'[($P($P(SDNODE,"^",3),";")_";")) Q
-	.;Extract and format Appointment Date/Time
-	.S Y=$P(SDNODE,"^",1)
-	.S $P(VAX("I"),"^",1)=Y
-	.X ^DD("DD") S $P(VAX("E"),"^",1)=Y
-	.;Extract and format Clinic Information
-	.S $P(VAX("I"),"^",2)=$P($P(SDNODE,"^",2),";",1)
-	.S $P(VAX("E"),"^",2)=$P($P(SDNODE,"^",2),";",2)
-	.;Extract and format Appointment Type
-	.S $P(VAX("I"),"^",4)=$P($P(SDNODE,"^",10),";",1)
-	.S $P(VAX("E"),"^",4)=$P($P(SDNODE,"^",10),";",2)
-	.;Extract and format Appointment Status
-	.S Y=$P($P(VAZ,$P($P(SDNODE,"^",3),";")_";",2),"^"),$P(VAX("I"),"^",3)=Y
-	.I Y]"" S X=$S($D(^DD(2.98,3,0)):$P(^(0),"^",3),1:""),$P(VAX("E"),"^",3)=$P($P(X,Y_":",2),";",1)
-	.S VAX(1)=VAX(1)+1
-	.;Store information in global
-	.S @VAV@(VAX(1),"I")=VAX("I"),@VAV@(VAX(1),"E")=VAX("E")
-	K ^TMP($J,"SDAMA301")
-	Q
+VADPT5 ;ALB/MRL/MJK - PATIENT VARIABLES [REG]; 14 DEC 1988 ; 8/6/04 7:42am
+ ;;5.3;Registration;**54,63,242,584**;Aug 13, 1993
+10 ;Registration/Disposition [REG]
+ N VARPSV
+ S VARPSV("C")=$S('$G(VARP("C")):999999999,1:+VARP("C"))
+ S VARPSV("F")=9999999-$S($G(VARP("F"))?7N.E:VARP("F"),1:0)
+ S VARPSV("T")=$S($G(VARP("T"))?7N.E:VARP("T"),1:7777777) I '$P(VARPSV("T"),".",2) S $P(VARPSV("T"),".",2)=999999
+ S VARPSV("T")=9999999-VARPSV("T")
+ S VAX=VARPSV("T"),VAX(1)=0
+ I '$D(^DPT(DFN,"DIS")) Q
+ F I=0:0 S VAX=$O(^DPT(DFN,"DIS",VAX)) Q:VAX=""!(VAX>VARPSV("F"))!(VAX(1)+1>VARPSV("C"))  S VAX(2)=$G(^DPT(DFN,"DIS",VAX,0)),VAX(1)=VAX(1)+1 D 101:+VAX(2)>0
+ Q
+101 S (VAX("I"),VAX("E"))="",VAX(3)=0 F I=1,2,3,4,5,6,7,9 S VAX(3)=VAX(3)+1,$P(VAX("I"),"^",VAX(3))=$P(VAX(2),"^",I) D 102
+ S @VAV@(VAX(1),"I")=VAX("I"),@VAV@(VAX(1),"E")=VAX("E") Q
+102 I "^1^6^"[("^"_VAX(3)_"^") S Y=$P(VAX("I"),"^",VAX(3)) I Y]"" X ^DD("DD") S $P(VAX("E"),"^",VAX(3))=Y Q
+ S X(1)=$S($D(^DD(2.101,$S(I<9:(I-1),1:I),0)):$P(^(0),"^",3),1:"") I "^2^3^"[("^"_VAX(3)_"^"),$P(VAX("I"),"^",VAX(3))]"",X(1)]"" S $P(VAX("E"),"^",VAX(3))=$P($P(X(1),$P(VAX("I"),"^",VAX(3))_":",2),";",1) Q
+ I "^4^5^7^8^"[("^"_VAX(3)_"^"),$P(VAX("I"),"^",VAX(3))]"",X(1)]"" S X(1)="^"_X(1)_$P(VAX("I"),"^",VAX(3))_",0)" I $D(@(X(1))) S $P(VAX("E"),"^",VAX(3))=$P(^(0),"^",1)
+ Q
+ ;
+11 ;Clinic Enrollments [SDE]
+ S (VAX,VAX(1))=0 F I=0:0 S VAX=$O(^DPT(DFN,"DE",VAX)) Q:VAX'>0  S VAZ=$S($D(^DPT(DFN,"DE",VAX,0)):^(0),1:"") I +VAZ,$P(VAZ,"^",2)'="I" S VAX(3)=0 D 111
+ Q
+111 S VAX(4)=0 F I1=0:0 S VAX(4)=$O(^DPT(DFN,"DE",VAX,1,VAX(4))) Q:VAX(4)'>0!(VAX(3))  S VAZ(1)=$S($D(^DPT(DFN,"DE",VAX,1,VAX(4),0)):^(0),1:"") I +VAZ(1),$P(VAZ(1),"^",3)']"" S VAX(3)=VAZ(1)
+ Q:'VAX(3)  S (VAX("I"),VAX("E"))="",Y=+VAX(3),$P(VAX("I"),"^",2)=Y X ^DD("DD") S $P(VAX("E"),"^",2)=Y
+ S $P(VAX("I"),"^",3)=$P(VAX(3),"^",2) I $P(VAX("I"),"^",3)]"" S $P(VAX("E"),"^",3)=$S($P(VAX("I"),"^",3)="O":"OPT",$P(VAX("I"),"^",3)="A":"AC",1:"")
+ S $P(VAX("I"),"^",1)=+VAZ,$P(VAX("E"),"^",1)=$S($D(^SC(+VAZ,0)):$P(^(0),"^",1),1:""),VAX(1)=VAX(1)+1,@VAV@(VAX(1),"I")=VAX("I"),@VAV@(VAX(1),"E")=VAX("E") Q
+ ;
+12 ;Appointments [SDA]
+ N VASDSV,SDCNT,SDARRAY
+ D NOW^%DTC
+ S VASDSV("F")=$S($G(VASD("F"))?7N.E:VASD("F"),1:%)
+ S VASDSV("T")=$S(+$G(VASD("T")):+VASD("T"),1:9999999) I '$P(VASDSV("T"),".",2) S $P(VASDSV("T"),".",2)=999999
+ S VASDSV("W")=$S('$G(VASD("W")):12,1:VASD("W"))
+ S VAZ(2)=$S($D(VASD("N")):VASD("N"),1:9999)
+ ;Set STATUS Codes (VistA;RSA)
+ S VAZ=";R^I;I^N;NS^NA;NSR^C;CC^CA;CCR^PC;CP^PCA;CPR^NT;NT^",VAZ(1)=""
+ ;Extract User Required STATUS Codes in RSA format
+ F I=1:1 S I1=+$E(VASDSV("W"),I) Q:'I1  D
+ .S VAZ(1)=VAZ(1)_$P($P(VAZ,"^",I1),";",2)_";"
+ ;Create parameter list for the extrinsic call to the Appointment API
+ ;Note: Appointment API can only accept a maximum of 3 fields 
+ ;               to filter on.
+ ; 1 : "FROM;TO" Appointment Date Range to Search
+ ; 2 : Clinic IEN or Array of Clinic IENs if defined (Pass the Root)
+ ; 3 : Requested STATUS Codes (Passed if VASD("C") is not defined.)
+ ; 4 : Patient IEN
+ S SDARRAY="",SDARRAY(1)=VASDSV("F")_";"_VASDSV("T")
+ I $O(VASD("C",0))>0 S SDARRAY(2)="VASD(""C"","
+ E  S SDARRAY(3)=VAZ(1)
+ S SDARRAY(4)=DFN
+ ;Set Fields for API to Return
+ ;  1 : Appointment Date/Time
+ ;  2 : Clinic
+ ;  3 : Appointment Status
+ ; 10 : Appointment Type
+ S SDARRAY("FLDS")="1;2;3;10"
+ ;Remove Clinic IEN from Global Reference
+ S SDARRAY("SORT")="P"
+ ;Call Appointment API (Pass Array by reference)
+ S SDCNT=$$SDAPI^SDAMA301(.SDARRAY)
+ S VAX="",VAX(1)=0
+ ;If error returned, determine error and set VAERR appropriately
+ ; 1 : For any error other than 101
+ ; 2 : If error is 101 : Database is unavailable  
+ I SDCNT<0 S VAX=$O(^TMP($J,"SDAMA301",VAX)) S VAERR=$S(VAX=101:2,1:1) K ^TMP($J,"SDAMA301") Q
+ D 122:SDCNT>0
+ Q
+121 S VAX(5)=1 I VASDSV("W")'[1,$P(VAZ,"^",2)']"" S VAX(5)=0 Q
+ I VASDSV("C"),'$D(VASD("C",+VAZ)) S VAX(5)=0 Q
+ S (VAX("I"),VAX("E"))="",VAX(2)=1,$P(VAX("I"),"^",1)=+VAX F I1=1,2,16 S VAX(2)=VAX(2)+1,$P(VAX("I"),"^",VAX(2))=$P(VAZ,"^",I1)
+ Q
+122 ;Build Internal/External Output Globals
+ ;
+ N SDCIEN,SDDTM,SDNODE
+ S (SDCIEN,SDDTM)=""
+ ;Redefine VAZ (STATUS Codes(RSA;VistA))
+ S VAZ="R;^I;I^NS;N^NSR;NA^CC;C^CCR;CA^CP;PC^CPR;PCA^NT;NT^"
+ S SDDTM=""
+ ;Loop through appointments and convert for output
+ F  S SDDTM=$O(^TMP($J,"SDAMA301",DFN,SDDTM)) Q:'SDDTM  D 
+ .;Get Appointment Information and clear VAX("I") & VAX("E")
+ .S SDNODE=^(SDDTM),(VAX("I"),VAX("E"))=""
+ .;If Clinics were passed to appointment API,
+ .;     Filter on Appointment Status Codes
+ .I $O(VASD("C",0))>0,(VAZ(1)'[($P($P(SDNODE,"^",3),";")_";")) Q
+ .;Extract and format Appointment Date/Time
+ .S Y=$P(SDNODE,"^",1)
+ .S $P(VAX("I"),"^",1)=Y
+ .X ^DD("DD") S $P(VAX("E"),"^",1)=Y
+ .;Extract and format Clinic Information
+ .S $P(VAX("I"),"^",2)=$P($P(SDNODE,"^",2),";",1)
+ .S $P(VAX("E"),"^",2)=$P($P(SDNODE,"^",2),";",2)
+ .;Extract and format Appointment Type
+ .S $P(VAX("I"),"^",4)=$P($P(SDNODE,"^",10),";",1)
+ .S $P(VAX("E"),"^",4)=$P($P(SDNODE,"^",10),";",2)
+ .;Extract and format Appointment Status
+ .S Y=$P($P(VAZ,$P($P(SDNODE,"^",3),";")_";",2),"^"),$P(VAX("I"),"^",3)=Y
+ .I Y]"" S X=$S($D(^DD(2.98,3,0)):$P(^(0),"^",3),1:""),$P(VAX("E"),"^",3)=$P($P(X,Y_":",2),";",1)
+ .S VAX(1)=VAX(1)+1
+ .;Store information in global
+ .S @VAV@(VAX(1),"I")=VAX("I"),@VAV@(VAX(1),"E")=VAX("E")
+ K ^TMP($J,"SDAMA301")
+ Q
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT61.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT61.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT61.m	(revision 623)
@@ -1,60 +1,60 @@
-VADPT61	;ALB/MJK - Patient ID Utilities (cont.); 12 AUG 89 @1200
-	;;5.3;Registration,;**749**;Aug 13, 1993;Build 10
-	;
-1	;;ID Format Enter/Edit
-	W ! S DIC="^DIC(8.2,",DIC(0)="AELMQ" D ^DIC K DIC G Q1:+Y<1
-	S DA=+Y,DIE="^DIC(8.2,",DR="[DG ID FORMAT ENTER/EDIT]" D ^DIE G 1
-Q1	K DIE,DR,DA,Y Q
-	;
-2	;;Eligibility Code Enter/Edit
-	W ! S DIC="^DIC(8,",DIC(0)="AELMQ",DIC("DR")=8 D ^DIC K DIC G Q2:+Y<1
-	S DA=+Y,DIE="^DIC(8,",DR="[DG ELIG ENTER/EDIT]" D ^DIE G 2
-Q2	K DIE,DR,DA,Y
-	Q
-	;
-ASK	;
-	Q:$S('$D(^DIC(8.2,+$P(^DIC(8,VAELG,0),U,10),0)):1,1:'$P(^(0),U,2))
-	W !!,*7,"User Input Needed for '",$P(^DIC(8,VAELG,0),U),"' id:"
-	S DIE="^DPT("_DFN_",""E"",",DR=.03,DA(1)=DFN,DA=VAELG D ^DIE
-	W !!?5,"...",$P(^DIC(8,VAELG,0),U)
-	K DIE,DR,DA,Y
-	Q
-	;
-WARN	; -- interaction warning
-	I $P(X,U,2) W !!?5,*7,"WARNING: User interaction usually is required for this format."
-	Q
-	;
-BEG	;
-	S VASTART=$$NOW^XLFDT
-	Q
-	;
-END	;
-	S VAEND=$$NOW^XLFDT,L=0
-	K XMY
-	S XMSUB=$P($T(OPTS+VAOPT),";",4),XMDUZ=.5,XMTEXT="VATEXT(",XMY(DUZ)=""
-	I VAOPT=3 S XMSUB=XMSUB_" (Format: "_$S($D(^DIC(8.2,VAFMT,0)):$P(^(0),U),1:"UNKNOWN")_")"
-	I VAOPT=5 S XMSUB=XMSUB_" (Eligibility: "_$S($D(^DIC(8,VAELG,0)):$P(^(0),U),1:"UNKNOWN")_")"
-	S L=L+1 S VATEXT(L,0)=" "
-	S Y=VASTART,L=L+1 X ^DD("DD") S VATEXT(L,0)="  Job started   at "_Y
-	S Y=VAEND,L=L+1 X ^DD("DD") S VATEXT(L,0)="  Job completed at "_Y
-	D ^XMD
-	K VAOPT,VASTART,VAEND,L,VATEXT,XMY,XMSUB,XMDUZ,XMTEXT,Y,% Q
-	;
-TASK	;
-	W !!?5,"The resetting of ID formats can take many hours."
-	W !?5,"It is suggested that it be run at off-peak hours,"
-	W !?5,"perferably over a weekend.",!
-	K ZTSK S X=$T(OPTS+VAOPT),VARS=$P(X,";",5)
-	F I=1:1 S Y=$P(VARS,"^",I) Q:Y=""  S ZTSAVE(Y)=""
-	S ZTSAVE("VAOPT")="",ZTRTN="QUE"_VAOPT_"^VADPT60",ZTDESC=$P(X,";",4),ZTIO="" D ^%ZTLOAD
-	I $D(ZTSK) W !!,"Job has been queued. (Task #",ZTSK,")",!,"A MailMan message will be sent to you when the job has completed."
-TASKQ	K ZTIO,ZTRTN,ZTDESC,ZTSAVE,VARS,Y,X,ZTSK Q
-	;
-OPTS	; -- queue task list ;;opt#;description;vars to save
-	;;1;none
-	;;2;none
-	;;3;Reset ID Format;VAFMT
-	;;4;Reset Primary Eligibilty ID Format
-	;;5;Reset Specific Eligibilty ID Format;VAELG
-	;;6;none
-	;;7;Reset All ID Formats for all Patients
+VADPT61 ;ALB/MJK - Patient ID Utilities (cont.); 12 AUG 89 @1200
+ ;;5.3;Registration;;Aug 13, 1993
+ ;
+1 ;;ID Format Enter/Edit
+ W ! S DIC="^DIC(8.2,",DIC(0)="AELMQ" D ^DIC K DIC G Q1:+Y<1
+ S DA=+Y,DIE="^DIC(8.2,",DR="[DG ID FORMAT ENTER/EDIT]" D ^DIE G 1
+Q1 K DIE,DR,DA,Y Q
+ ;
+2 ;;Eligibility Code Enter/Edit
+ W ! S DIC="^DIC(8,",DIC(0)="AELMQ",DIC("DR")=8 D ^DIC K DIC G Q2:+Y<1
+ S DA=+Y,DIE="^DIC(8,",DR="[DG ELIG ENTER/EDIT]" D ^DIE G 2
+Q2 K DIE,DR,DA,Y
+ Q
+ ;
+ASK ;
+ Q:$S('$D(^DIC(8.2,+$P(^DIC(8,VAELG,0),U,10),0)):1,1:'$P(^(0),U,2))
+ W !!,*7,"User Input Needed for '",$P(^DIC(8,VAELG,0),U),"' id:"
+ S DIE="^DPT("_DFN_",""E"",",DR=.03,DA(1)=DFN,DA=VAELG D ^DIE
+ W !!?5,"...",$P(^DIC(8,VAELG,0),U)
+ K DIE,DR,DA,Y
+ Q
+ ;
+WARN ; -- interaction warning
+ I $P(X,U,2) W !!?5,*7,"WARNING: User interaction usually is required for this format."
+ Q
+ ;
+BEG ;
+ D NOW^%DTC S VASTART=%
+ Q
+ ;
+END ;
+ D NOW^%DTC S VAEND=%,L=0
+ K XMY
+ S XMSUB=$P($T(OPTS+VAOPT),";",4),XMDUZ=.5,XMTEXT="VATEXT(",XMY(DUZ)=""
+ I VAOPT=3 S XMSUB=XMSUB_" (Format: "_$S($D(^DIC(8.2,VAFMT,0)):$P(^(0),U),1:"UNKNOWN")_")"
+ I VAOPT=5 S XMSUB=XMSUB_" (Eligibility: "_$S($D(^DIC(8,VAELG,0)):$P(^(0),U),1:"UNKNOWN")_")"
+ S L=L+1 S VATEXT(L,0)=" "
+ S Y=VASTART,L=L+1 X ^DD("DD") S VATEXT(L,0)="  Job started   at "_Y
+ S Y=VAEND,L=L+1 X ^DD("DD") S VATEXT(L,0)="  Job completed at "_Y
+ D ^XMD
+ K VAOPT,VASTART,VAEND,L,VATEXT,XMY,XMSUB,XMDUZ,XMTEXT,Y,% Q
+ ;
+TASK ;
+ W !!?5,"The resetting of ID formats can take many hours."
+ W !?5,"It is suggested that it be run at off-peak hours,"
+ W !?5,"perferably over a weekend.",!
+ K ZTSK S X=$T(OPTS+VAOPT),VARS=$P(X,";",5)
+ F I=1:1 S Y=$P(VARS,"^",I) Q:Y=""  S ZTSAVE(Y)=""
+ S ZTSAVE("VAOPT")="",ZTRTN="QUE"_VAOPT_"^VADPT60",ZTDESC=$P(X,";",4),ZTIO="" D ^%ZTLOAD
+ I $D(ZTSK) W !!,"Job has been queued. (Task #",ZTSK,")",!,"A MailMan message will be sent to you when the job has completed."
+TASKQ K ZTIO,ZTRTN,ZTDESC,ZTSAVE,VARS,Y,X,ZTSK Q
+ ;
+OPTS ; -- queue task list ;;opt#;description;vars to save
+ ;;1;none
+ ;;2;none
+ ;;3;Reset ID Format;VAFMT
+ ;;4;Reset Primary Eligibilty ID Format
+ ;;5;Reset Specific Eligibilty ID Format;VAELG
+ ;;6;none
+ ;;7;Reset All ID Formats for all Patients
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VAFCPID.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VAFCPID.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VAFCPID.m	(revision 623)
@@ -1,123 +1,121 @@
-VAFCPID	;ALB/MLI,PKE-Create generic PID segment ; 21 Nov 2002  3:13 PM
-	;;5.3;Registration;**91,149,190,415,508,749**;Aug 13, 1993;Build 10
-	;
-	; This routine returns the HL7 defined PID segment with its
-	; mappings to DHCP PATIENT file fields.
-	;
-EN(DFN,VAFSTR,VAFNUM)	; returns PID segment
-	;  Input - DFN as internal entry number of the PATIENT file
-	;          VAFSTR as string of fields requested separated by commas
-	;          VAFNUM as sequential number for SET ID (default=1)
-	;
-	;      ****Also assumes all HL7 variables returned from****
-	;          INIT^HLTRANS are defined
-	;
-	; Output - String containing the desired components of the PID segment
-	;          VAFPID(n) - if the string is longer than 245, the remaining
-	;                      characters will be returned in VAFPID(n) where
-	;                      n is a sequential number beginning with 1
-	;
-	; WARNING: This routine makes external calls to VADPT.  Non-namespaced
-	;          variables may be altered.
-	;
-	N I,VAFY,VA,VADM,X,X1,Y,OUTPUT,DGNAME,DGMMN,VAPA ; calls VADPT...have to NEW
-	S VAFSTR=$G(VAFSTR) ; if not defined, just return required fields
-	S DFN=$G(DFN)
-	I DFN']"" G QUIT
-	;Get demographics and permanent address
-	S VAPA("P")="" D 4^VADPT
-	S VAFSTR=","_VAFSTR_","
-	K VAFY
-	;Set ID (#1)
-	I VAFSTR[",1," S VAFY(1)=$S($G(VAFNUM):VAFNUM,1:1)
-	;External ID (#2 - always included)
-	S X=$$GETICN^MPIF001(DFN) S:(+X=-1) X="" S VAFY(2)=$S(X]"":X,1:HLQ)
-	;Patient ID (#3 - req)
-	S VAFY(3)=$$M10^HLFNC(DFN)
-	;Alternate ID (#4)
-	I VAFSTR[",4," S X=$G(VA("BID")),VAFY(4)=$S(X]"":X,1:HLQ)
-	;Name (#5 - req)
-	S DGNAME("FILE")=2,DGNAME("IENS")=DFN,DGNAME("FIELD")=.01
-	S X=$$HLNAME^XLFNAME(.DGNAME,"",$E(HLECH)),VAFY(5)=$S(X]"":X,1:HLQ)
-	;Mother's maiden name (#6)
-	I VAFSTR[",6," D
-	.S DGMMN("FILE")=2,DGMMN("IENS")=DFN,DGMMN("FIELD")=.2403
-	.S X=$$HLNAME^XLFNAME(.DGMMN,"",$E(HLECH)),VAFY(6)=$S(X]"":X,1:HLQ)
-	;Date of birth (#7)
-	I VAFSTR[",7," S VAFY(7)=$$HLDATE^HLFNC(+VADM(3))
-	;Sex (#8)
-	I VAFSTR[",8," S X=$P(VADM(5),"^",1),VAFY(8)=$S("^M^F^"[("^"_X_"^"):X,1:"U")
-	;Race (#10)
-	I VAFSTR[10 D
-	.N HOW
-	.S Y=$F(VAFSTR,"10")
-	.S HOW=$P($E(VAFSTR,Y,$F(VAFSTR,",",Y)),",",1)
-	.D SEQ10^VAFHLPI1(HOW,HLQ)
-	;Address (#11)
-	I VAFSTR[11 D
-	.N HOW
-	.S Y=$F(VAFSTR,"11")
-	.S HOW=$P($E(VAFSTR,Y,$F(VAFSTR,",",Y)),",",1)
-	.D SEQ11^VAFHLPI2(HOW,HLQ)
-	;County (#12)
-	I VAFSTR[12 S X1=$P($G(^DIC(5,+$G(VAPA(5)),1,+$G(VAPA(7)),0)),"^",3),VAFY(12)=$S(X1]"":X1,1:HLQ)
-	S X=$G(^DPT(DFN,.13))
-	;Home phone (#13)
-	I VAFSTR[13 S X1=$$HLPHONE^HLFNC($P(X,"^",1)),VAFY(13)=$S(X1]"":X1,1:HLQ)
-	;Business phone (#14)
-	I VAFSTR[14 S X1=$$HLPHONE^HLFNC($P(X,"^",2)),VAFY(14)=$S(X1]"":X1,1:HLQ)
-	;Marital status (#16)
-	I VAFSTR[16 S X=$P($G(^DIC(11,+VADM(10),0)),"^",3),VAFY(16)=$S(X="M":"M",X="N":"S",X="S":"A",X]"":X,1:HLQ)
-	;Religious preference (#17) (if blank send 29 (UNKNOWN))
-	I VAFSTR[17 S X=$P($G(^DIC(13,+VADM(9),0)),"^",4),VAFY(17)=$S(X]"":X,1:29)
-	;SSN (#19)
-	I VAFSTR[19 S X=$P(VADM(2),"^",1),VAFY(19)=$S(X]"":X,1:HLQ)
-	;Ethnicity (#22)
-	I VAFSTR[22 D
-	.N HOW
-	.S Y=$F(VAFSTR,"22")
-	.S HOW=$P($E(VAFSTR,Y,$F(VAFSTR,",",Y)),",",1)
-	.D SEQ22^VAFHLPI1(HOW,HLQ)
-	;Birth place (#23)
-	I VAFSTR[23 D
-	.N DGBC,DGBS
-	.S DGBC=$$GET1^DIQ(2,DFN,.092,"I")
-	.S DGBS=$$GET1^DIQ(2,DFN,.093,"E")
-	.S VAFY(23)=DGBC_" "_DGBS
-	;Date of death (#29) & Death indicator (#30) (always included if dead)
-	S X=+VADM(6) I X D
-	.S VAFY(29)=$$HLDATE^HLFNC(X)
-	.S VAFY(30)="Y"
-	;
-QUIT	D KVA^VADPT
-	D MAKEIT^VAFHLU("PID",.VAFY,.OUTPUT,.VAFPID)
-	Q OUTPUT
-	;
-ADDR(VAFADDR,VAFCOUNT)	;Return HL7 address
-	; Input  - VAFADDR as address in format:
-	;            line1^line2^line3^city^state^zip+4
-	;          VAFCOUNT as internal value of county (optional)
-	; Output - HL7 v2.3 formatted Address_HLFS_County Code
-	;
-	;      ****Also assumes all HL7 variables returned from****
-	;          INIT^HLTRANS are defined
-	;
-	N X,Y,Z S X=$E(HLECH)
-	;Street address (line 1)
-	S $P(Y,X,1)=$P(VAFADDR,"^",1)
-	;Other designation (line 2)
-	S $P(Y,X,2)=$P(VAFADDR,"^",2)
-	;City
-	S $P(Y,X,3)=$P(VAFADDR,"^",4)
-	;State
-	S $P(Y,X,4)=$P($G(^DIC(5,+$P(VAFADDR,"^",5),0)),"^",2)
-	;Zip
-	S $P(Y,X,5)=$P(VAFADDR,"^",6)
-	;Other geographic designation (line 3)
-	S $P(Y,X,8)=$P(VAFADDR,"^",3)
-	;County
-	S $P(Y,X,9)=$P($G(^DIC(5,+$P(VAFADDR,"^",5),1,+$G(VAFCOUNT),0)),"^",3)
-	F Z=1,2,3,4,5,8,9 I $P(Y,X,Z)="" S $P(Y,X,Z)=HLQ
-	I $G(VAFCOUNT) D
-	.S $P(Y,HLFS,2)=$P(Y,X,9)
-	Q Y
+VAFCPID ;ALB/MLI,PKE-Create generic PID segment ; 21 Nov 2002  3:13 PM
+ ;;5.3;Registration;**91,149,190,415,508**;Aug 13, 1993
+ ;
+ ; This routine returns the HL7 defined PID segment with its
+ ; mappings to DHCP PATIENT file fields.
+ ;
+EN(DFN,VAFSTR,VAFNUM) ; returns PID segment
+ ;  Input - DFN as internal entry number of the PATIENT file
+ ;          VAFSTR as string of fields requested separated by commas
+ ;          VAFNUM as sequential number for SET ID (default=1)
+ ;
+ ;      ****Also assumes all HL7 variables returned from****
+ ;          INIT^HLTRANS are defined
+ ;
+ ; Output - String containing the desired components of the PID segment
+ ;          VAFPID(n) - if the string is longer than 245, the remaining
+ ;                      characters will be returned in VAFPID(n) where
+ ;                      n is a sequential number beginning with 1
+ ;
+ ; WARNING: This routine makes external calls to VADPT.  Non-namespaced
+ ;          variables may be altered.
+ ;
+ N I,VAFY,VA,VADM,X,X1,Y,OUTPUT,DGNAME,VAPA ; calls VADPT...have to NEW
+ S VAFSTR=$G(VAFSTR) ; if not defined, just return required fields
+ S DFN=$G(DFN)
+ I DFN']"" G QUIT
+ ;Get demographics and permanent address
+ S VAPA("P")="" D 4^VADPT
+ S VAFSTR=","_VAFSTR_","
+ K VAFY
+ ;Set ID (#1)
+ I VAFSTR[",1," S VAFY(1)=$S($G(VAFNUM):VAFNUM,1:1)
+ ;External ID (#2 - always included)
+ S X=$$GETICN^MPIF001(DFN) S:(+X=-1) X="" S VAFY(2)=$S(X]"":X,1:HLQ)
+ ;Patient ID (#3 - req)
+ S VAFY(3)=$$M10^HLFNC(DFN)
+ ;Alternate ID (#4)
+ I VAFSTR[",4," S X=$G(VA("BID")),VAFY(4)=$S(X]"":X,1:HLQ)
+ ;Name (#5 - req)
+ S DGNAME("FILE")=2,DGNAME("IENS")=DFN,DGNAME("FIELD")=.01
+ S X=$$HLNAME^XLFNAME(.DGNAME,"",$E(HLECH)),VAFY(5)=$S(X]"":X,1:HLQ)
+ ;Mother's maiden name (#6)
+ I VAFSTR[",6," S X=$P($G(^DPT(DFN,.24)),"^",3),VAFY(6)=$S(X]"":X,1:HLQ)
+ ;Date of birth (#7)
+ I VAFSTR[",7," S VAFY(7)=$$HLDATE^HLFNC(+VADM(3))
+ ;Sex (#8)
+ I VAFSTR[",8," S X=$P(VADM(5),"^",1),VAFY(8)=$S("^M^F^"[("^"_X_"^"):X,1:"U")
+ ;Race (#10)
+ I VAFSTR[10 D
+ .N HOW
+ .S Y=$F(VAFSTR,"10")
+ .S HOW=$P($E(VAFSTR,Y,$F(VAFSTR,",",Y)),",",1)
+ .D SEQ10^VAFHLPI1(HOW,HLQ)
+ ;Address (#11)
+ I VAFSTR[11 D
+ .N HOW
+ .S Y=$F(VAFSTR,"11")
+ .S HOW=$P($E(VAFSTR,Y,$F(VAFSTR,",",Y)),",",1)
+ .D SEQ11^VAFHLPI2(HOW,HLQ)
+ ;County (#12)
+ I VAFSTR[12 S X1=$P($G(^DIC(5,+$G(VAPA(5)),1,+$G(VAPA(7)),0)),"^",3),VAFY(12)=$S(X1]"":X1,1:HLQ)
+ S X=$G(^DPT(DFN,.13))
+ ;Home phone (#13)
+ I VAFSTR[13 S X1=$$HLPHONE^HLFNC($P(X,"^",1)),VAFY(13)=$S(X1]"":X1,1:HLQ)
+ ;Business phone (#14)
+ I VAFSTR[14 S X1=$$HLPHONE^HLFNC($P(X,"^",2)),VAFY(14)=$S(X1]"":X1,1:HLQ)
+ ;Marital status (#16)
+ I VAFSTR[16 S X=$P($G(^DIC(11,+VADM(10),0)),"^",3),VAFY(16)=$S(X="M":"M",X="N":"S",X="S":"A",X]"":X,1:HLQ)
+ ;Religious preference (#17) (if blank send 29 (UNKNOWN))
+ I VAFSTR[17 S X=$P($G(^DIC(13,+VADM(9),0)),"^",4),VAFY(17)=$S(X]"":X,1:29)
+ ;SSN (#19)
+ I VAFSTR[19 S X=$P(VADM(2),"^",1),VAFY(19)=$S(X]"":X,1:HLQ)
+ ;Ethnicity (#22)
+ I VAFSTR[22 D
+ .N HOW
+ .S Y=$F(VAFSTR,"22")
+ .S HOW=$P($E(VAFSTR,Y,$F(VAFSTR,",",Y)),",",1)
+ .D SEQ22^VAFHLPI1(HOW,HLQ)
+ ;Birth place (#23)
+ I VAFSTR[23 D
+ .N DGBC,DGBS
+ .S DGBC=$$GET1^DIQ(2,DFN,.092,"I")
+ .S DGBS=$$GET1^DIQ(2,DFN,.093,"E")
+ .S VAFY(23)=DGBC_" "_DGBS
+ ;Date of death (#29) & Death indicator (#30) (always included if dead)
+ S X=+VADM(6) I X D
+ .S VAFY(29)=$$HLDATE^HLFNC(X)
+ .S VAFY(30)="Y"
+ ;
+QUIT D KVA^VADPT
+ D MAKEIT^VAFHLU("PID",.VAFY,.OUTPUT,.VAFPID)
+ Q OUTPUT
+ ;
+ADDR(VAFADDR,VAFCOUNT) ;Return HL7 address
+ ; Input  - VAFADDR as address in format:
+ ;            line1^line2^line3^city^state^zip+4
+ ;          VAFCOUNT as internal value of county (optional)
+ ; Output - HL7 v2.3 formatted Address_HLFS_County Code
+ ;
+ ;      ****Also assumes all HL7 variables returned from****
+ ;          INIT^HLTRANS are defined
+ ;
+ N X,Y,Z S X=$E(HLECH)
+ ;Street address (line 1)
+ S $P(Y,X,1)=$P(VAFADDR,"^",1)
+ ;Other designation (line 2)
+ S $P(Y,X,2)=$P(VAFADDR,"^",2)
+ ;City
+ S $P(Y,X,3)=$P(VAFADDR,"^",4)
+ ;State
+ S $P(Y,X,4)=$P($G(^DIC(5,+$P(VAFADDR,"^",5),0)),"^",2)
+ ;Zip
+ S $P(Y,X,5)=$P(VAFADDR,"^",6)
+ ;Other geographic designation (line 3)
+ S $P(Y,X,8)=$P(VAFADDR,"^",3)
+ ;County
+ S $P(Y,X,9)=$P($G(^DIC(5,+$P(VAFADDR,"^",5),1,+$G(VAFCOUNT),0)),"^",3)
+ F Z=1,2,3,4,5,8,9 I $P(Y,X,Z)="" S $P(Y,X,Z)=HLQ
+ I $G(VAFCOUNT) D
+ .S $P(Y,HLFS,2)=$P(Y,X,9)
+ Q Y
